<script>
import Controls from "./_design_1_Buttons.svelte";
import CustomLine from "./_design_1_line.svelte";

import { onMount } from "svelte";
import { json } from "d3-fetch";
import { max } from "d3-array";


  // Size and margins
  const width = 700;
  const height = 480;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

 


  // load data 
  let data = null;
  let buildingTypes = [];
  let heating = 0;

  let Buttoncity = "Los Angeles";
  let Buttonscaling = "per line";

  onMount(async () => {
    data = await json("/data/hourly_heating_december.json");
    data.forEach((elem) => {
      if (!buildingTypes.includes(elem.buildingtype)) {
        buildingTypes.push(elem.buildingtype);
      }
    });
    heating = max(
      data.filter((d) => d.city == Buttoncity),
      (d) => d.total_heating_energy
    );
  });

  $: heating = data
    ? max(
        data.filter((d) => d.city == Buttoncity),
        (d) => d.total_heating_energy
      )
    : 0;

</script>




{#if !data}
<text>Loading data...</text>
 
{:else}
<div>
  <p style="margin:10px">
    Graph 1: Hourly heating energy used per  building types
    in the chosen city during the month December. 
  </p>
  <Controls bind:city={Buttoncity} bind:scaling={Buttonscaling} />
  <svg {width} {height}>
    <g transform="translate({margin.left}, {margin.top})">
      {#each buildingTypes as buildingType, i}
        <CustomLine 
          {buildingType}
          {width}
          {height}
          {i}
          data={data.filter(
            (d) => d.city == Buttoncity && d.buildingtype == buildingType
          )}
          {heating}
          scaling={Buttonscaling}
        />
      {/each}
      <text x={5} y={height - 20} style="font-size:12">1 Dec</text>
      <text x={width - 210} y={height - 20} style="font-size:12"
        >31 Dec</text
      >
    </g>
  </svg>
</div>
{/if}



<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;}
  

</style>
